classdef NameIdxMap < handle
  %NAMEIDXMAP creates map of names mapped to integers
  
  properties
    map;
    idxNameCell = {};
  end
  
  methods
 
    function obj = NameIdxMap(varargin)
      obj.map = containers.Map;
    end
    
    function idx = put(obj, names)
      if ~iscell(names)
        names = {names};
      end
      idx = zeros(numel(names), 1);
      for iName = 1:numel(names)
        name = names{iName};
        if ~isKey(obj.map, name)
          obj.map(name) = obj.map.length +1;
          obj.idxNameCell{obj.map.length} = name;
        end
        idx(iName) = obj.map(name);
      end
    end
    
    function idx = get(obj, names)
      idx = obj.put(obj,names);
    end
    
    function [names, idx] = getSortedNames(obj)
      names = obj.map.keys();
      idx = obj.map.values(names);
      [idx, order] = sort(cell2mat(idx));
      names = names(order);
    end
  end
  
end

